// HSVOptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFCTEST4.h"
#include "HSVOptionDlg.h"
#include ".\hsvoptiondlg.h"


typedef pair<LPCSTR, HSVComparator::FUNC_TYPE> ft_pair;
typedef pair<LPCSTR, HSVComparator::EVAL_ORDER> et_pair;
typedef pair<LPCSTR, float> hb_pair;

const ft_pair HSVOptionDlg::h_func_type[] = {
	ft_pair(_T("Max."), HSVComparator::MAX), 
	ft_pair(_T("Min."), HSVComparator::MIN), 
	ft_pair(_T("Warm 1"), HSVComparator::WARM1), 
	//ft_pair(_T("Warm 2"), HSVComparator::WARM2), 
	ft_pair(_T("Cool 1"), HSVComparator::COOL1), 
	//ft_pair(_T("Cool 2"), HSVComparator::COOL2), 
};

const ft_pair HSVOptionDlg::s_func_type[] = {
	ft_pair(_T("Max."), HSVComparator::MAX), 
	ft_pair(_T("Min."), HSVComparator::MIN), 
};

const ft_pair HSVOptionDlg::v_func_type[] = {
	ft_pair(_T("Max."), HSVComparator::MAX), 
	ft_pair(_T("Min."), HSVComparator::MIN), 
};

const et_pair HSVOptionDlg::eval_type[] = {
	et_pair(_T("HSV"), HSVComparator::HSV), 
	et_pair(_T("SVH"), HSVComparator::SVH), 
	et_pair(_T("VHS"), HSVComparator::VHS), 
	et_pair(_T("VSH"), HSVComparator::VSH), 
	et_pair(_T("HVS"), HSVComparator::HVS), 
	et_pair(_T("SHV"), HSVComparator::SHV), 
};

const hb_pair HSVOptionDlg::huebreak_selection[] = {
	hb_pair(_T("Red (0.0)"), 0.f), 
	hb_pair(_T("Yellow (60.0)"), 60.f), 
	hb_pair(_T("Green (120.0)"), 120.f), 
	hb_pair(_T("Cyan (180.0)"), 180.f), 
	hb_pair(_T("Blue (240.0)"), 240.f), 
	hb_pair(_T("Magenta (300.0)"), 300.f), 
};


// HSVOptionDlg dialog

IMPLEMENT_DYNAMIC(HSVOptionDlg, CDialog)
HSVOptionDlg::HSVOptionDlg(VisView *pVisview, CWnd* pParent /*=NULL*/)
	: CDialog(HSVOptionDlg::IDD, pParent)
{
	parent = pParent;
	visview = pVisview;
}

HSVOptionDlg::~HSVOptionDlg()
{
}

void HSVOptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_HUE_BREAK_COMBO, hue_selection_combo);
}


BEGIN_MESSAGE_MAP(HSVOptionDlg, CDialog)
	ON_CBN_SELCHANGE(IDC_H_FUNC, OnCbnSelchangeHFunc)
	ON_CBN_SELCHANGE(IDC_S_FUNC, OnCbnSelchangeSFunc)
	ON_CBN_SELCHANGE(IDC_V_FUNC, OnCbnSelchangeVFunc)
	ON_CBN_SELCHANGE(IDC_HSV_EVAL_ORDER, OnCbnSelchangeHsvEvalOrder)
	ON_EN_KILLFOCUS(IDC_HUE_BREAK, OnEnKillfocusHueBreak)
	ON_NOTIFY(UDN_DELTAPOS, IDC_HUE_BREAK_SPIN, OnDeltaposHueBreakSpin)
	ON_WM_CTLCOLOR()
	ON_CBN_SELCHANGE(IDC_HUE_BREAK_COMBO, &HSVOptionDlg::OnCbnSelchangeHueBreakCombo)
END_MESSAGE_MAP()


// HSVOptionDlg message handlers

void HSVOptionDlg::OnCancel() {
	CDialog::OnCancel();
}


BOOL HSVOptionDlg::OnInitDialog()
{
	CComboBox *box;
	CEdit *edit;

	CDialog::OnInitDialog();

	box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_H_FUNC));
	box->AddString(h_func_type[0].first);
	box->AddString(h_func_type[1].first);
	box->AddString(h_func_type[2].first);
	box->AddString(h_func_type[3].first);
	//box->AddString(h_func_type[4].first);
	//box->AddString(h_func_type[5].first);

	for(int i = 0; i < 6; i++) {
		if(StrokeComparator::hsv_comp.getEvalFunc_H() == h_func_type[i].second) {
			box->SetCurSel(i);
			break;
		}
	}


	box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_S_FUNC));
	box->AddString(s_func_type[0].first);
	box->AddString(s_func_type[1].first);

	for(int i = 0; i < 2; i++) {
		if(StrokeComparator::hsv_comp.getEvalFunc_S() == s_func_type[i].second) {
			box->SetCurSel(i);
			break;
		}
	}


	box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_V_FUNC));
	box->AddString(v_func_type[0].first);
	box->AddString(v_func_type[1].first);

	for(int i = 0; i < 2; i++) {
		if(StrokeComparator::hsv_comp.getEvalFunc_V() == v_func_type[i].second) {
			box->SetCurSel(i);
			break;
		}
	}


	box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_HSV_EVAL_ORDER));
	box->AddString(eval_type[0].first);
	box->AddString(eval_type[1].first);
	box->AddString(eval_type[2].first);
	box->AddString(eval_type[3].first);
	box->AddString(eval_type[4].first);
	box->AddString(eval_type[5].first);

	for(int i = 0; i < 6; i++) {
		if(StrokeComparator::hsv_comp.getEvalOrder() == eval_type[i].second) {
			box->SetCurSel(i);
			break;
		}
	}


	edit = reinterpret_cast<CEdit*>(GetDlgItem(IDC_HUE_BREAK));
	setNumberToCEdit(edit, StrokeComparator::hsv_comp.getHueBreakPoint(), 1);


	for(int i = 0; i < 6; i++) {
		hue_selection_combo.AddString(huebreak_selection[i].first);
	}

	hue_selection_combo.SetCurSel(0);
	StrokeComparator::hsv_comp.setHueBreakPoint(huebreak_selection[0].second);


	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void HSVOptionDlg::OnCbnSelchangeHFunc() {
	CComboBox *box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_H_FUNC));
	StrokeComparator::hsv_comp.setEvalFunc_H(h_func_type[box->GetCurSel()].second);

	visview->initializeRendering();

	reinterpret_cast<TabContent1*>(parent)->setStrokeOrderInfoText();
}


void HSVOptionDlg::OnCbnSelchangeSFunc() {
	CComboBox *box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_S_FUNC));
	StrokeComparator::hsv_comp.setEvalFunc_S(s_func_type[box->GetCurSel()].second);

	visview->initializeRendering();

	reinterpret_cast<TabContent1*>(parent)->setStrokeOrderInfoText();
}


void HSVOptionDlg::OnCbnSelchangeVFunc() {
	CComboBox *box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_V_FUNC));
	StrokeComparator::hsv_comp.setEvalFunc_V(v_func_type[box->GetCurSel()].second);

	visview->initializeRendering();

	reinterpret_cast<TabContent1*>(parent)->setStrokeOrderInfoText();
}


void HSVOptionDlg::OnCbnSelchangeHsvEvalOrder() {
	CComboBox *box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_HSV_EVAL_ORDER));
	StrokeComparator::hsv_comp.setEvalOrder(eval_type[box->GetCurSel()].second);

	visview->initializeRendering();

	reinterpret_cast<TabContent1*>(parent)->setStrokeOrderInfoText();
}


void HSVOptionDlg::OnEnKillfocusHueBreak() {
	CEdit *edit = reinterpret_cast<CEdit*>(GetDlgItem(IDC_HUE_BREAK));
	StrokeComparator::hsv_comp.setHueBreakPoint((float)getNumberFromCEdit(edit));

	visview->initializeRendering();

	reinterpret_cast<TabContent1*>(parent)->setStrokeOrderInfoText();
}


void HSVOptionDlg::OnDeltaposHueBreakSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	float delta = 0.1f;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_HUE_BREAK));

	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, getNumberFromCEdit(ce) + delta, 1);
	OnEnKillfocusHueBreak();

	*pResult = 0;
}


void HSVOptionDlg::OnOK() {
	CWnd *wnd = GetFocus();

	if(wnd != NULL && wnd->GetDlgCtrlID() != IDC_HUE_BREAK) {
		CDialog::OnOK();
	}
	else {
		SetFocus();
	}
}


HBRUSH HSVOptionDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	float hsv[3], rgb[3];
	unsigned char rgb_ub[3];
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	CBrush brush;

	if(pWnd->GetDlgCtrlID() == IDC_HUE_COLOR) {
		hsv[0] = StrokeComparator::hsv_comp.getHueBreakPoint();
		hsv[1] = 1.f;
		hsv[2] = 1.f;

		HsvRgb(hsv, rgb);

		rgb_ub[0] = (unsigned char)(rgb[0] * 255);
		rgb_ub[1] = (unsigned char)(rgb[1] * 255);
		rgb_ub[2] = (unsigned char)(rgb[2] * 255);

		pDC->SetBkMode(OPAQUE);
		pDC->SetBkColor(RGB(rgb_ub[0], rgb_ub[1], rgb_ub[2]));
		pDC->SelectObject(&brush);
		hbr = brush;
	}

	return hbr;
}


void HSVOptionDlg::OnCbnSelchangeHueBreakCombo() {
	float val = huebreak_selection[hue_selection_combo.GetCurSel()].second;

	StrokeComparator::hsv_comp.setHueBreakPoint(val);

	visview->initializeRendering();

	reinterpret_cast<TabContent1*>(parent)->setStrokeOrderInfoText();
}
