#pragma once
#include <string>

using namespace std;


class ImageLoader {
public:
	ImageLoader();
	~ImageLoader();

	void load(string filename, bool fill_padding, unsigned char **pixels, int &w, int &h);
	void load(const char *filename, bool fill_padding, unsigned char **pixels, int &w, int &h);
	void readFile(string filename, bool fill_padding, unsigned char **pixels, int &w, int &h);
	void readPPM(const char *filename, unsigned char **pixels, int &w, int &h);
	void readJPG(const char *filename, unsigned char **pixels, int &w, int &h);
	void readBMP(const char *filename, unsigned char **pixels, int &w, int &h);

	void setPaddingColor(const unsigned char rgb[3]);
	void getPaddingColor(unsigned char rgb[3]);

private:
	void squarize(unsigned char **pixels, int &w, int &h);

	void addPaddingBottom(int num_pixels, unsigned char **pixels, int &w, int &h);
	void addPaddingRight(int num_pixels, unsigned char **pixels, int &w, int &h);

	unsigned char padding_color[3];
};