#include "StdAfx.h"
#include "ShaderProgram.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

ShaderProgram::ShaderProgram(ShaderObject* NewVSObject, ShaderObject* NewGSObject, ShaderObject* NewPSObject, GLuint NewProgram)
{
	VSObject = NewVSObject;
	GSObject = NewGSObject;
	PSObject = NewPSObject;
	hProgram = NewProgram;

	if(VSObject) {
		glAttachShader(hProgram,VSObject->GetShaderHandle());
		VS_supplied = true;
	}
	else  {
		VSObject = new ShaderObject("", VS);
		VS_supplied = false;
	}

	if(GSObject) {
		glAttachShader(hProgram,GSObject->GetShaderHandle());
		GS_supplied = true;
	}
	else {
		GSObject = new ShaderObject("", GS);
		GS_supplied = false;
	}

	if(PSObject) {
		glAttachShader(hProgram,PSObject->GetShaderHandle());
		PS_supplied = true;
	}
	else {
		PSObject = new ShaderObject("", PS);
		PS_supplied = false;
	}

	glLinkProgram(hProgram);
}
ShaderProgram::~ShaderProgram()
{
	if(VS_supplied == false) delete VSObject;
	if(GS_supplied == false) delete GSObject;
	if(PS_supplied == false) delete PSObject;

}