#ifndef __SHADERPROGRAM__
#define __SHADERPROGRAM__

#pragma once
#include "GLSLUtil.h"
#include "ShaderObject.h"

class ShaderProgram
{
public:
	ShaderProgram(ShaderObject* NewVSObject, ShaderObject* NewGSObject, ShaderObject* NewPSObject, GLuint NewProgram);
	~ShaderProgram();
	
	ShaderObject*	GetVS(void)
					{return VSObject;};
	ShaderObject*	GetGS(void)
					{return GSObject;};
	ShaderObject*	GetPS(void)
					{return PSObject;};
	GLuint			GetProgramHandle(void)
					{return hProgram;};
private:
	ShaderObject*	VSObject;
	ShaderObject*	GSObject;
	ShaderObject*	PSObject;
	GLuint			hProgram;

	bool VS_supplied;
	bool GS_supplied;
	bool PS_supplied;
};
#endif