uniform sampler2D tex0;		// stroke height
uniform sampler2D tex1;		// stroke shape
uniform float jitter_scale;
varying vec2 height_tex_coord;

const float frac = 1.0 / 255.0;

void main() {
	float shift = texture2D(tex0, height_tex_coord).r;
	float alpha = texture2D(tex1, gl_TexCoord[0].st).a;

	if(alpha == 0.0) discard;

	//gl_FragColor = vec4(vec3(gl_Color.rgb + (2.0 * shift - 1.0) * jitter_scale * frac), gl_Color.a * alpha);
	gl_FragColor = vec4(vec3(gl_Color.rgb - shift * jitter_scale * frac), gl_Color.a * alpha);
}
