uniform sampler2D tex0;
uniform sampler2D tex1;
uniform int func;
uniform float bgfg_threshold;


float squareSumColor(in vec4 inColor) {
	return (inColor.r*inColor.r + inColor.g*inColor.g + inColor.b*inColor.b);
}

int LessThan(in vec4 color1, in vec4 color2) {
	if(
		(color1.g < color2.g) || 
		(color1.g == color2.g && color1.r < color2.r) || 
		(color1.g == color2.g && color1.r == color2.r && color1.b < color2.b)
	) {
		return 1;
	}
	else {
		return 0;
	}
}

int MoreThan(in vec4 color1, in vec4 color2) {
	if(
		(color1.g > color2.g) || 
		(color1.g == color2.g && color1.r > color2.r) || 
		(color1.g == color2.g && color1.r == color2.r && color1.b > color2.b)
	) {
		return 1;
	}
	else {
		return 0;
	}
}


void main() {
	vec4 c0 = texture2D(tex0, gl_TexCoord[0].st);
	vec4 c1 = texture2D(tex1, gl_TexCoord[0].st);
	float inten0 = squareSumColor(c0);
	float inten1 = squareSumColor(c1);


	if(c0.a < bgfg_threshold) {
		gl_FragColor = c1;
	}
	else if(c1.a < bgfg_threshold) {
		gl_FragColor = c0;
	}
	else if(func == 0) {				// MIN
		if(inten0 < inten1) {
			gl_FragColor = c0;
		}
		else if(inten0 > inten1) {
			gl_FragColor = c1;
		}
		else if(LessThan(c0, c1) == 1) {
			gl_FragColor = c0;
		}
		else {
			gl_FragColor = c1;
		}
	}
	else if(func == 1) {			// MAX
		if(inten0 > inten1) {
			gl_FragColor = c0;
		}
		else if(inten0 < inten1) {
			gl_FragColor = c1;
		}
		else if(MoreThan(c0, c1) == 1) {
			gl_FragColor = c0;
		}
		else {
			gl_FragColor = c1;
		}
	}
	else {
		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
	}
}


