uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float bgfg_threshold;

float squareSumColor(vec4 inColor) {
	return (inColor.r*inColor.r + inColor.g*inColor.g + inColor.b*inColor.b);
}

float LessThan(vec4 color1, vec4 color2) {
	if(
		(color1.g < color2.g) || 
		(color1.g == color2.g && color1.r < color2.r) || 
		(color1.g == color2.g && color1.r == color2.r && color1.b < color2.b)
	) {
		return 1.0;
	}
	else {
		return 0.0;
	}
}

void main() {
	vec4 c0  = texture2D(tex0,gl_TexCoord[0].st);
	vec4 c1  = texture2D(tex1,gl_TexCoord[0].st);
	float i0 = 0.0;
	float i1 = 0.0;

	if(c0.a < bgfg_threshold) {
		gl_FragColor = c1;
	}
	else if(c1.a < bgfg_threshold) {
		gl_FragColor = c0;
	}
	else {
		i0 = squareSumColor(c0);
		i1 = squareSumColor(c1);

		if(i0 < i1) {
			gl_FragColor = c0;
		}
		else if(i0 > i1) {
			gl_FragColor = c1;
		}
		else if(LessThan(c0, c1) == 1.0) {
			gl_FragColor = c0;
		}
		else  {
			gl_FragColor = c1;
		}
	}
}
