#pragma once


typedef struct StrokeParams {
	StrokeParams() {
		stroke_size = 10.f;
		stroke_gridsize = 512.f;
		stroke_position_jitter = 0;
		stroke_color_jitter = 0;
		stroke_opacity = 255.f;
		stroke_displacemnt = 0;
		stroke_min_length = 0;
		stroke_max_length = 0;
		stroke_color_shift[0] = 0;
		stroke_color_shift[1] = 0;
		stroke_color_shift[2] = 0;
	}

	StrokeParams(
		float size, float gridsize, float pos_jitter, float color_jitter, float opacity, float displacement, int min_len, int max_len, 
		float color_shift_h, float color_shift_s, float color_shift_v
	) {
		stroke_size = size;
		stroke_gridsize = gridsize;
		stroke_position_jitter = pos_jitter;
		stroke_color_jitter = color_jitter;
		stroke_opacity = opacity;
		stroke_displacemnt = displacement;
		stroke_min_length = min_len;
		stroke_max_length = max_len;
		stroke_color_shift[0] = color_shift_h;
		stroke_color_shift[1] = color_shift_s;
		stroke_color_shift[2] = color_shift_v;
	}

	float stroke_size;						// diameter
	float stroke_gridsize;					// how much spacing each stroke occupies
	float stroke_position_jitter;			// from -100 to 100, ignored if alignment is not regular grid pattern
	float stroke_color_jitter;
	float stroke_opacity;					// from 0 to 255... scales each stroke's opacity
	float stroke_displacemnt;
	int stroke_min_length;
	int stroke_max_length;
	float stroke_color_shift[3];

} StrokeParams;

