// TabContent2.cpp : implementation file
//

#pragma once
#include "stdafx.h"
#include "TabContent2.h"
#include ".\tabcontent2.h"

using namespace std;



// TabContent2 dialog

IMPLEMENT_DYNAMIC(TabContent2, CDialog)


TabContent2::TabContent2(CMFCTEST4Dlg* pParent)
	: CDialog(TabContent2::IDD, pParent)
{
	ASSERT(pParent != NULL);
	Create(IDD, pParent);
	this->parent = pParent;
	initializeValues();
}


TabContent2::~TabContent2()
{
}

void TabContent2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(TabContent2, CDialog)
	ON_BN_CLICKED(IDC_DBG_STROKE_GAP_IMG, &TabContent2::OnBnClickedDbgStrokeGapImg)
	ON_BN_CLICKED(IDC_DBG_WARPED_IMG, &TabContent2::OnBnClickedDbgWarpedImg)
	ON_BN_CLICKED(IDC_DBG_ADDITIONAL_STROKE_MASK, &TabContent2::OnBnClickedDbgAdditionalStrokeMask)
	ON_BN_CLICKED(IDC_DBG_INITIAL_STROKE_IMG, &TabContent2::OnBnClickedDbgInitialStrokeImg)
	ON_BN_CLICKED(IDC_SET_VIDEO_RENDERING_RANGE, &TabContent2::OnBnClickedSetVideoRenderingRange)
	ON_EN_KILLFOCUS(IDC_VIDEO_RENDERING_RANGE_START, &TabContent2::OnEnKillfocusVideoRenderingRangeStart)
	ON_EN_KILLFOCUS(IDC_VIDEO_RENDERING_RANGE_END, &TabContent2::OnEnKillfocusVideoRenderingRangeEnd)
	ON_EN_KILLFOCUS(IDC_DBG_SHOW_EACH_LAYER, OnEnKillfocusDbgShowEachLayer)
	ON_NOTIFY(UDN_DELTAPOS, IDC_DBG_SHOW_EACH_LAYER_SPIN, OnDeltaposDbgShowEachLayerSpin)
	ON_BN_CLICKED(IDC_DBG_SHOW_EACH_LAYER_CHECK, OnBnClickedDbgShowEachLayerCheck)
	ON_BN_CLICKED(IDC_DBG_OPTFLOWVIS, OnBnClickedDbgOptflowvis)
	ON_BN_CLICKED(IDC_DBG_WARPING_OPTION, &TabContent2::OnBnClickedDbgWarpingOption)
	ON_EN_KILLFOCUS(IDC_DBG_BGFG, &TabContent2::OnEnKillfocusDbgBgfg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_DBG_BGFG_SPIN, &TabContent2::OnDeltaposDbgBgfgSpin)
END_MESSAGE_MAP()


void TabContent2::OnOK() {}
void TabContent2::OnCancel() {}

void TabContent2::initializeValues() {
	int val;
	VisView *visview;

	visview = parent->getVisView();

	setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_VIDEO_RENDERING_RANGE_START)), 0);
	setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_VIDEO_RENDERING_RANGE_END)), 0);

	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_START_CAPTION)->EnableWindow(FALSE);
	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_END)->EnableWindow(FALSE);
	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_END_CAPTION)->EnableWindow(FALSE);

	reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_SHOW_EACH_LAYER_CHECK))->SetCheck(0);
	setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DBG_SHOW_EACH_LAYER)), visview->getNumEnabledLayers());
	OnBnClickedDbgShowEachLayerCheck();

	val = visview->getRenderingOption_b(VisView::IBFV_USE_GL_NEAERST_IN_WARP) ? 1 : 0;
	reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_WARPING_OPTION))->SetCheck(val);

	val = visview->getRenderingOption_uc(VisView::IBFV_BGFG);
	setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DBG_BGFG)), val);
}


void TabContent2::OnBnClickedDbgStrokeGapImg()
{
	VisView *visview = parent->getVisView();
	int val = reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_STROKE_GAP_IMG))->GetCheck();

	visview->dbg_output_stroke_map = ((val == 1) ? true : false);
}


void TabContent2::OnBnClickedDbgWarpedImg()
{
	VisView *visview = parent->getVisView();
	int val = reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_WARPED_IMG))->GetCheck();

	visview->dbg_save_advection_image = ((val == 1) ? true : false);
}


void TabContent2::OnBnClickedDbgAdditionalStrokeMask()
{
	VisView *visview = parent->getVisView();
	int val = reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_ADDITIONAL_STROKE_MASK))->GetCheck();

	visview->dbg_save_stroke_placement_mask = ((val == 1) ? true : false);
}


void TabContent2::OnBnClickedDbgInitialStrokeImg()
{
	VisView *visview = parent->getVisView();
	int val = reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_INITIAL_STROKE_IMG))->GetCheck();

	visview->dbg_show_only_initial_stroke_image = ((val == 1) ? true : false);
}



void TabContent2::OnBnClickedSetVideoRenderingRange()
{
	BOOL enabled;
	int val = reinterpret_cast<CButton*>(GetDlgItem(IDC_SET_VIDEO_RENDERING_RANGE))->GetCheck();

	if(val == 0) {
		enabled = FALSE;
		parent->setVideoRenderingRange(0, -1);
	}
	else {
		enabled = TRUE;
		OnEnKillfocusVideoRenderingRangeStart();
	}

	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_START)->EnableWindow(enabled);
	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_START_CAPTION)->EnableWindow(enabled);
	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_END)->EnableWindow(enabled);
	GetDlgItem(IDC_VIDEO_RENDERING_RANGE_END_CAPTION)->EnableWindow(enabled);
}


void TabContent2::OnEnKillfocusVideoRenderingRangeStart()
{
	CEdit *start_frame = reinterpret_cast<CEdit*>(GetDlgItem(IDC_VIDEO_RENDERING_RANGE_START));
	CEdit *end_frame = reinterpret_cast<CEdit*>(GetDlgItem(IDC_VIDEO_RENDERING_RANGE_END));
	int start_val = (int)getNumberFromCEdit(start_frame) - 1;
	int end_val = (int)getNumberFromCEdit(end_frame) - 1;
	
	parent->setVideoRenderingRange(start_val, end_val);

	setNumberToCEdit(start_frame, parent->getVideoRenderingStartFrame() + 1);
	setNumberToCEdit(end_frame, parent->getVideoRenderingEndFrame() + 1);
}


void TabContent2::OnEnKillfocusVideoRenderingRangeEnd()
{
	OnEnKillfocusVideoRenderingRangeStart();
}


void TabContent2::OnEnKillfocusDbgShowEachLayer() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DBG_SHOW_EACH_LAYER));
	int val = (int)::getNumberFromCEdit(ce);


	val = (int)::clampVal(val, 1, visview->getMaxSupportedLayers());

	::setNumberToCEdit(ce, val);
	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->dbg_show_layer_idx = val - 1;

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent2::OnDeltaposDbgShowEachLayerSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DBG_SHOW_EACH_LAYER));
	int val = (int)::getNumberFromCEdit(ce);


	if(pNMUpDown->iDelta > 0) delta *= -1;

	val = (int)::clampVal(val + delta, 1, visview->getMaxSupportedLayers());

	::setNumberToCEdit(ce, val);
	OnEnKillfocusDbgShowEachLayer();

	*pResult = 0;
}


void TabContent2::OnBnClickedDbgShowEachLayerCheck() {
	BOOL val;
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	if(reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_SHOW_EACH_LAYER_CHECK))->GetCheck() == 0) {
		val = FALSE;
	}
	else {
		val = TRUE;
	}

	GetDlgItem(IDC_DBG_SHOW_EACH_LAYER)->EnableWindow(val);
	GetDlgItem(IDC_DBG_SHOW_EACH_LAYER_SPIN)->EnableWindow(val);

	prev_timer_status = visview->getDisplayTimerStatus();	
	visview->stopDisplayTimer();
	visview->dbg_show_layer = ((val == TRUE) ? true : false);
	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent2::OnBnClickedDbgOptflowvis() {
	VisView *visview = parent->getVisView();

	if(reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_OPTFLOWVIS))->GetCheck() == 0) {
		visview->dbg_show_optflow = false;
	}
	else {
		visview->dbg_show_optflow = true;
		parent->copyOptFlowForVis();
	}
}

void TabContent2::OnBnClickedDbgWarpingOption() {
	VisView *visview = parent->getVisView();

	if(reinterpret_cast<CButton*>(GetDlgItem(IDC_DBG_WARPING_OPTION))->GetCheck() == 0) {
		visview->setRenderingOption_b(VisView::IBFV_USE_GL_NEAERST_IN_WARP, false);
	}
	else {
		visview->setRenderingOption_b(VisView::IBFV_USE_GL_NEAERST_IN_WARP, true);
	}
}

void TabContent2::OnEnKillfocusDbgBgfg() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DBG_BGFG));
	int val = (int)::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setRenderingOption_uc(VisView::IBFV_BGFG, (unsigned char)val);

	val = visview->getRenderingOption_uc(VisView::IBFV_BGFG);
	::setNumberToCEdit(ce, val);


	if(prev_timer_status == true) visview->startDisplayTimer();
}

void TabContent2::OnDeltaposDbgBgfgSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DBG_BGFG));
	int val = (int)::getNumberFromCEdit(ce);


	if(pNMUpDown->iDelta > 0) delta *= -1;

	val = (int)::clampVal(val + delta, 0, 255);

	::setNumberToCEdit(ce, val);
	OnEnKillfocusDbgBgfg();

	*pResult = 0;
}
