#pragma once
#include <map>
#include <vector>
#include <utility>
#include "PaintingPreset.h"

using namespace std;


class TransitionalPaintingPreset {
public:
	static enum INTERPOLATION_TYPE {
		UNDEFINED, 
		LINEAR, 
		SQUARE_ROOT1, 
		CUBE_ROOT1, 
		SQUARE_ROOT2, 
		CUBE_ROOT2, 
		EASE, 
	};


private:
	map<int, PaintingPreset> keyframes;
	map<int, INTERPOLATION_TYPE> key_interpolations;

public:
	TransitionalPaintingPreset() {};
	TransitionalPaintingPreset(PaintingPreset key);
	~TransitionalPaintingPreset();


	PaintingPreset get(int t = 0);
	size_t getSize();
	int getNextKey(int t = 0);
	int getPrevKey(int t = 0);
	bool set(PaintingPreset key, int t = 0);
	bool remove(int t = 0);
	void copy(const TransitionalPaintingPreset &src);
	void getAllKeys(vector< pair<int, PaintingPreset> > &keys);
	void setAllKeys(const vector< pair<int, PaintingPreset> > &keys);


	void setInterpolationFunc(TransitionalPaintingPreset::INTERPOLATION_TYPE func_type, int t = 0);
	INTERPOLATION_TYPE getInterpolationFunc(int t = 0);
	void getAllInterpolationFuncs(vector< pair<int, INTERPOLATION_TYPE> > &functions);
	void setAllInterpolationFuncs(const vector< pair<int, INTERPOLATION_TYPE> > &functions);
};